#if !defined(CWatchThread_HEADER)
#define CWatchThread_HEADER

#include "WatchThread.hpp"
#include "SettingInfo.hpp"

#include "tstring.hpp"
#include <vector>

class CWatchThreadGroup
{
private:
	CWatchThreadGroup( const CWatchThreadGroup& ); //<! Ȃ
	operator=( const CWatchThreadGroup& ); //<! Ȃ

public:
	
	/*!
	 * ĎXbhO[v\z܂B
	 * hC[hLɂƃXbh͎ۂɂ͍쐬ꂸҏŴ݂ƂȂ܂B
	 * \param v_dryrun hC[h̏ꍇAtrue
	 */
	CWatchThreadGroup( const bool v_dryrun );

	virtual ~CWatchThreadGroup();
	
	void ReleaseAllThreads();

	const CSettingInfo& getInfo( unsigned int idx ) const;
	unsigned int size() const;

	bool append( const CSettingInfo& v_settingInfo );
	bool replace( unsigned int idx, const CSettingInfo& v_settingInfo );
	bool erase( unsigned int idx );

	bool isRunning() const;
	bool isDryrRun() const;

	bool LoadInfData( const tstring& InfPath );
	bool SaveInfData( const tstring& InfPath, bool bForce = false ) const;
	bool isModified() const;

private:
	const bool dryrun_;
	mutable bool modified_;

	typedef std::vector<CWatchThread*> CWatchThreadList;
	CWatchThreadList watchList_;
};

#endif
