#include "stdafx.hpp"
#include "FWatchApp.hpp"
#include "resource.h"

FWatchApp* pApp;

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	DEBUGBLOCK(
		_CrtSetDbgFlag( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );
	);

	const FWatchAppPtr app = FWatchApp::createFWatchApp();
	pApp = app.get();

	if( FAILED( ::CoInitializeEx( NULL, COINIT_APARTMENTTHREADED ) ) ){
		pApp->showMessageBox( MB_ICONERROR | MB_OK, NULL, IDS_MAINPROC_COINITFAILED );
		return 1;
	}

	const int result = pApp->run( lpCmdLine );

	::CoUninitialize();
	return result;
}
