#ifndef INCLUDE_H_TSTRINGUTY
#define INCLUDE_H_TSTRINGUTY

#include "tstring.hpp"

#include <iterator>

class tstringuty {
private:
	tstringuty(); //<! Ȃ
public:

	/*!
	* 𕶎ƂĕԂ܂B
	* ԂIuWFNg͈ꎞIuWFNgłB
	* \param v_value 
	* \return 
	*/
	static tstring IntToString( int v_value ) throw();

	/*!
	* 𕶎ɕϊĕԂ܂B
	* ԂIuWFNg͈ꎞIuWFNgłB
	* \param v_format tH[}bg
	* \return 
	*/
	static tstring ToString( const LPCTSTR v_format, ... ) throw();

	/*!
	* ̑OɊ܂܂󔒂ƃ^v菜Ԃ܂B
	* ͔j󂳂܂B
	* Ԃ镶͈ꎞIIuWFNgłB
	*/
	static tstring trimSpaceBoth( const tstring& v_in );

	/*!
	* 񂪎w肵ŏI[邱ƂۏႵ܂B
	* ͔j󂳂܂B
	* Ԃ镶͈ꎞIuWFNgłB
	* \param v_str 
	* \param v_endStr I[镶
	* \return I[Ă邱ƂۏႳꂽ(ꎞIuWFNg)
	*/
	static tstring ensureEndsWith( const tstring& v_str, const tstring& v_endStr ) throw();

	/*!
	* JEg܂B
	* _uoCg̏ꍇ2oCg1JEg܂B
	* \return 
	*/
	static tstring::size_type getCharCount( const tstring& v_str ) throw();

	/*!
	 * w肵̃CfbNXԂ܂B
	 * _uoCg̏ꍇ2oCg1JEg܂B
	 * ۂ̒̕傫ꍇ͏I[+1()Ԃ܂B
	 * \param v_str 
	 * \param v_index 
	 * \return CfbNX
	 */
	static tstring::size_type getCharIndex( const tstring& v_str, tstring::size_type v_index ) throw();

	/*!
	 * ̌琔Ďw肵̃CfbNXԂ܂B
	 * _uoCg̏ꍇ2oCg1JEg܂B
	 * ۂ̒̕傫ꍇ0Ԃ܂B
	 * \param v_str 
	 * \param v_lastIndex 
	 * \return CfbNX
	 */
	static tstring::size_type getCharLastIndex( const tstring& v_str, tstring::size_type v_lastIndex ) throw();

	static bool isMatch( const tstring& v_text, const tstring& v_pattern ) throw();

	/*!
	* 񂩂琮(int)擾܂B
	* s󔒂͖܂B
	* \param v_text 
	* \return 
	*/
	static int atoi( const tstring& v_text ) throw();

	/*!
	* 񂩂琮(long)擾܂B
	* s󔒂͖܂B
	* \param v_text 
	* \return 
	*/
	static int atol( const tstring& v_text ) throw();

	/*!
	* 񂩂琮(long long)擾܂B
	* s󔒂͖܂B
	* \param v_text 
	* \return 
	*/
	static __int64 atoi64( const tstring& v_text ) throw();

};

template<class T> void split( const tstring& v_line, TCHAR v_chr, std::insert_iterator<T> v_ite ) throw()
{
	const tstring::size_type len = v_line.length();
	tstring::size_type idx = 0;
	tstring::size_type lastIdx = 0;
	for(;;) {
		const tstring::value_type ch = ( idx < len ) ? v_line[ idx ] : 0;
		if( ch == v_chr || ch == 0 ) {
			const tstring token = v_line.substr( lastIdx, idx - lastIdx );
			if( ! token.empty() ) {
				*v_ite++ = token;
			}
			lastIdx = idx + 1;
		}
		if( idx >= len ) {
			break;
		}
#ifndef _UNICODE
		if( ::IsDBCSLeadByte( ch ) ) {
			idx++;
		}
#endif
		idx++;
	}
}

#endif
